import { Elysia } from 'elysia'
import db from '../Database'
import { User } from './index.ts'
import { authenticator } from 'otplib';

const user = new User();

const userController = new Elysia()
    .post('/login', async ({ body }) => {
        const msg = db.query(`select id, password, otp from users WHERE username = ?;`)
            .get(body.username)
        console.log(msg)
        if(msg == null) return new Response("Invalid username or password", { status: 401 })
        const validPassword = await Bun.password.verify(body.password, msg.password)
        if (!validPassword) return new Response("Invalid username or password", { status: 401 })
        // if(!authenticator.check(body.otp, msg.otp)) return new Response("Invalid OTP code", { status: 401 })
        return await user.createToken(msg.id)
    })
    .post('/register', async({body}) => {
        return await Bun.password.hash(body.password);
    })
    .get('/otp', () => {
        return authenticator.generateSecret();
    })

export default userController
